  MEMBER

! 11.18.03 Maurice L. Pilotte maurice@jmpsoftware.com

! There are no guarantees that go along with this class.
! You're on your own. But if you should come up with any improvements,
! add the date and your name and email address to the list above and please email them to me.

! Clarion 6 does not generate EVENT:GainFocus and EVENT:LoseFocus as before.
! The only time I can see is when closing a MDI window and another gains focus.
! This class is an attempt at restoring these events as they were.

! cFocus class determines if window is MDI or now and executes accordingly.

! These class files are designed to be copied into the app folder or in a redirection file path

! In global include embed:
! INCLUDE('Focus.Inc'), ONCE

! Data embed of procedure:
! Focus (or whatever)               cFocus

! In embed immediately after opening window:
! Focus.Initialize


OMIT('ThisIsC5', _C55_)
!_ABCDllMode_  EQUATE(1)        !Remove comments if compiling from non-root DLL
!_ABCLinkMode_ EQUATE(0)

!_ABCDllMode_  EQUATE(0)        !Remove comments if compiling from root DLL
!_ABCLinkMode_ EQUATE(1)
ThisIsC5

  INCLUDE('Focus.Inc'), ONCE

  INCLUDE('ABERROR.INC'), ONCE

HWND                                EQUATE(ULONG)
WPARAM                              EQUATE(ULONG)
UINT                                EQUATE(ULONG)
LPARAM                              EQUATE(LONG)
LRESULT                             EQUATE(LONG)

WM_NCACTIVATE                       EQUATE(0086h)

WM_ACTIVATE                         EQUATE(0006h)

! WM_ACTIVATE state values

WA_INACTIVE                         EQUATE(0)
WA_ACTIVE                           EQUATE(1)
WA_CLICKACTIVE                      EQUATE(2)


  MAP
    AppWindowProc( ULONG MyhWnd, ULONG usMsg, ULONG wParam, LONG lParam ), LONG, PASCAL

    MODULE('Windows')
      CallWindowProc( LONG lpPrevWndFunc, HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam ), LRESULT, PASCAL, RAW, NAME( 'CallWindowProcA')
      
    .
  .

SaveWindow                          LONG, THREAD
IsGain                              BYTE, THREAD
IsLose                              BYTE, THREAD


cFocus.Initialize                       PROCEDURE

IsMDI                               BYTE

  CODE
  SaveWindow      = 0{PROP:WNDProc}
  IsMDI           = 0{PROP:MDI}
  0{PROP:WndProc} = ADDRESS( AppWindowProc )
  IF IsMDI ! MDI currently only window generating events - frame window does not like to work with REGISTER
    REGISTER( EVENT:GainFocus, ADDRESS( SELF.EventHandler ), ADDRESS( SELF ))
    REGISTER( EVENT:LoseFocus, ADDRESS( SELF.EventHandler ), ADDRESS( SELF ))
  .
  RETURN


! Catch any Clarion generated EVENT:GainFocus and EVENT:LoseFocus - only let pass class generated events
cFocus.EventHandler                     PROCEDURE!(), BYTE, PROTECTED

Result                              BYTE(Level:Benign)

  CODE
  CASE EVENT()
  OF EVENT:GainFocus
    IF IsGain
      IsGain = FALSE
    ELSE ! the only Clarion generated event and we don't want duplicates
      Result = Level:Notify
    .
  OF EVENT:LoseFocus
    IF IsLose
      IsLose = FALSE
    ELSE ! the only Clarion generated event and we don't want duplicates
      Result = Level:Notify
    .
  .
  RETURN Result


!!!!!!!!!!!!!! Local procedures

AppWindowProc                           PROCEDURE( ULONG MyhWnd, ULONG usMsg, ULONG wParam, LONG lParam )

IsMDI                               BYTE
wParamGrp                           GROUP, OVER(wParam)
Low                                   USHORT
High                                  USHORT
                                    .

  CODE
  IsMDI = 0{PROP:MDI}
  CASE usMsg
  OF WM_NCACTIVATE
    IF IsMDI
      IF wParam
        IsGain = TRUE
        POST( EVENT:GainFocus )
      ELSE
        IsLose = TRUE
        POST( EVENT:LoseFocus )
      .
    .

  OF WM_ACTIVATE
    IF ~IsMDI
      CASE wParamGrp.Low
      OF WA_INACTIVE
        IF ~lParam = 0{PROP:Handle}
          POST( EVENT:LoseFocus )
        .
      OF WA_ACTIVE
        IF ~lParam = 0{PROP:Handle}
          POST( EVENT:GainFocus )
        .
      OF WA_CLICKACTIVE
        IF ~lParam = 0{PROP:Handle}
          POST( EVENT:GainFocus )
        .
      .
    .

  .
  RETURN CallWindowProc( SaveWindow, MyhWnd, usMsg, wParam, lParam )
